
package
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.media.*;
	import gs.*;

	public class Shield extends Sprite
	{
		public var game: Game;
		
		[Embed(source="images/shield.png")]
		public static var shieldGfx: Class;
		
		[Embed(source="audio/shield.mp3")]
		public static var hitSfx: Class;
		
		private var image: Bitmap;
		
		private var hitSound: Sound;
		
		private var timer: int = 0;
		
		public function Shield (_game: Game, i: int = 0)
		{
			hitSound = new hitSfx();
			
			game = _game;
			
			x = 72 + 135*i + ((i >= 2) ? 1 : 0);
			y = 480 - 64 - 55;
			
			image = new shieldGfx();
			
			addChild(image);
		}
		
		public function update (): void {
			if (timer > 0) {
				timer -= 20;
			}
		}
		
		public function check (bullet: *): void
		{
			var point: Point = new Point(bullet.x, bullet.y);
			
			point = image.globalToLocal(point);
			
			var colour: uint = image.bitmapData.getPixel32(point.x, point.y);
			
			var alpha: uint = (colour >> 24) & 0xFF;

			var hit: Boolean;
			
			if (bullet is Bullet) {
				hit = (alpha > 0);
			} else {
				hit = PixelPerfectCollisionDetection.isColliding(bullet, this, game, true);
			}
			
			if (hit)
			{
				var w: int = 5 + Math.random() * 3;
				var h: int = 3 + Math.random() * 2;
				
				if (! (bullet is Bullet)) {
					w += Math.random() * 2 + 1;
					h += Math.random() * 2 + 1;
				}
				
				var rect: Rectangle = new Rectangle(point.x - w, point.y - h, w*2, h*2);
				
				image.bitmapData.fillRect(rect, 0x00000000);
				
				//w = 2 + Math.random() * 4;
				//h = 4 + Math.random() * 4;
				
				w -= 2;
				h += 2;
				
				rect = new Rectangle(point.x - w, point.y - h, w*2, h*2);
				
				image.bitmapData.fillRect(rect, 0x00000000);
				
				if (bullet is Bullet) {
					bullet.y = -50;
				} else {
					//bullet.y = 600;
					
					/*if (! bullet.dying) {
						TweenLite.to(bullet, 0.2, {vx: 0, vy: 0, vRot: 0, gravity: 0, scaleX: 0, scaleY: 0});
					}*/
					
					bullet.vx *= 0.5;
					bullet.vy *= 0.5;
					bullet.vRot *= 0.8;
					bullet.gravity *= 0.8;
					bullet.scaleX -= 0.15;
					bullet.scaleY -= 0.15;
					
					if (bullet.scaleX < 0) {
						bullet.y = 600;
					}
				}
				
				if (timer <= 0) {
					//hitSound.play();
					timer = 250;
				}
				
				/*point.x = rect.x + 8;
				point.y = rect.y + 8;
				
				point = image.localToGlobal(point);
				
				addDebris(point.x, point.y, vx);*/
			}
		}
		
		/*public function addDebris (x: Number, y:Number, vx: Number = 0, vy: Number = 0): void {
			var particle: DebrisParticle = new DebrisParticle(x, y, vx, vy);
			
			particle.graphics.beginFill(0x111111);
			particle.graphics.drawRect(-8, -8, 16, 16);
			particle.graphics.endFill();
			
			particle.graphics.beginFill(0xc12121);
			particle.graphics.drawRect(-7, -7, 14, 14);
			particle.graphics.endFill();
			
			game.addDebris(particle);
		}*/
	}

}


